;**********************************************************************
;                                                                     *
;    Filename:	    timerlsv.asm                                      *
;    Date:          22.10.01                                          *
;    File Version:  1.01                                              *
;                                                                     *
;    Author:        Dmitry Salikoff                                   *
;    Company:       DISALL co                                         *
;                                                                     * 
;                                                                     *
;**********************************************************************
;                                                                     *
;    Files required:       -    *
;                     .            *   
;                     .                                        *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Notes:             - 4 .                    *
;                       .                     *
;                                                                     *
;                                                                     *
;           		                         	              *
;								      *
;                                                                     *
;**********************************************************************
;  
;      .   
;    .     .
;        .
;
;   3  (180 )  0   0,1 .
;    999,9   0



	list      p=16F84             ; list directive to define processor
	#include <p16F84.inc>         ; processor specific variable definitions

	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

;**********************************************************************
;***** VARIABLE DEFINITIONS
 	cblock 0x0C		;   
 w_temp                         ; variable used for context saving 
 status_temp                    ; variable used for context saving
	endc

	cblock 0x30		;    0
 cnt0,cnt1,cnt2			;      
 raz1,raz2,raz3,raz4		; ,   . raz1 -  
 flash				;      
 cher				;     
 flags				; 
 time				;    0,1 
 dig1,dig2,dig3,dig4		;   
 cnt_mig			;    
 tmr_add			;     0
 	endc

 #define relepriz flags,0	;   
 #define justsub flags,1	;   
 #define sndpriz flags,2	;  
 #define key_touch flags,3	;   
 #define mig flags,4		;  
 #define keys flags,5		;     

 #define snd PORTA,4		; 
 #define rele PORTB,7		; 
 #define key_start PORTB,0	;  
 #define key_0 PORTA,3
 #define key_1 PORTA,2
 #define key_2 PORTA,1
 #define key_3 PORTA,0
 #define key_4 PORTB,6
 #define key_5 PORTB,5
 #define key_6 PORTB,4
 #define key_7 PORTB,3
 #define key_8 PORTB,2
 #define key_9 PORTB,1


 #define _c STATUS, C
 #define _z STATUS, Z 
 #define _t0if INTCON, T0IF
 #define _t0ie INTCON, T0IE
 #define _gie INTCON, GIE
 #define _rbif INTCON, RBIF
 #define _rbie INTCON, RBIE
 #define _inte INTCON, INTE
 #define _intf INTCON, INTF
 #define _eeif EECON1, EEIF
 #define _wr EECON1, WR
 #define _wren EECON1, WREN



;  
;                     76543210
PORTA_NAPR_IND	EQU B'11100000'		;    
PORTB_NAPR_IND	equ b'00000000'		
PORTA_NAPR_K1	EQU B'11100000'		;     
PORTB_NAPR_K1	equ B'01111111'
PORTA_NAPR_K2	equ B'11101111'		;      
PORTB_NAPR_K2	equ B'00000000'

porta		equ PORTA
portb		equ PORTB
fsr		equ FSR
indf		equ INDF

;  ************************************************************
pisk		macro dlit		;     0,1 
		movlw dlit
		call sound
		endm
pause		macro dlit
		movlw dlit
		call delay
		endm
rele_on		macro
		bsf rele
		bsf relepriz
		endm
rele_off	macro
		bcf rele
		bcf relepriz
		endm
snd_on		macro
		bcf snd
		bsf sndpriz
		endm
snd_off		macro
		bsf snd
		bcf sndpriz
		endm


;**********************************************************************
		ORG     0x000             ; processor reset vector
  		goto    main              ; go to beginning of program
		ORG     0x004             ; interrupt vector location
	           			  ;  
		movwf   w_temp            ; save off current W register contents
		movf	STATUS,w          ; move status register into W register
		movwf	status_temp       ; save off contents of STATUS register

		movlw .8		;    250  
		addwf TMR0,f
		bcf _t0if
		decfsz tmr_add,f
		goto prer_exit
;		movlw .8
		movlw .4		;       (1:2)?
		movwf tmr_add

;		movlw .7
;		movwf TMR0
;		bcf _t0if

		decfsz time,f		;  
		goto prer20
		movlw .50
		movwf time
		bcf justsub

prer20		movlw raz1		;  
		movwf FSR
		movf cher,w
		addwf FSR,f
;		incf cher,f		;  ,  
		movlw 3			;     
		subwf cher,w
		btfss _z
		goto prer21
;		clrf cher
		movlw b'11110111'	;  
		goto prer29
prer21		movlw 2
		subwf cher,w
		btfss _z
		goto prer22
		movlw b'11111011'
		goto prer29
prer22		movlw 1
		subwf cher,w
		btfss _z
		goto prer23
		movlw b'11111101'
		goto prer29
prer23		movlw b'11111110'
prer29		btfsc sndpriz
		andlw b'11101111'
		movwf porta		

		


		
prer43		incf cnt_mig,f		;  
		btfss mig		;    ?
		goto prer40
		movf cher,w		;    ?
		subwf flash,w
		btfss _z
		goto prer40		; -,  
		btfss cnt_mig,5		;    ,  ?
		goto prer40		;   
		goto prer41		;  (     )
prer40

		movlw 0			;  
		subwf INDF,w
		btfsc _z
		goto prer1
		movlw 1
		subwf indf,w
		btfsc _z
		goto prer2
		movlw 2
		subwf indf,w
		btfsc _z
		goto prer3
		movlw 3
		subwf indf,w
		btfsc _z
		goto prer4
		movlw 4
		subwf indf,w
		btfsc _z
		goto prer5
		movlw 5
		subwf indf,w
		btfsc _z
		goto prer6
		movlw 6
		subwf indf,w
		btfsc _z
		goto prer7
		movlw 7
		subwf indf,w
		btfsc _z
		goto prer8
		movlw 8
		subwf indf,w
		btfsc _z
		goto prer9
		goto prer10

;			 gfedcba
prer1		movlw b'00111111'	; 0
		goto prer11
prer2		movlw b'00000110'	; 1
		goto prer11
prer3		movlw b'01011011'	; 2
		goto prer11
prer4		movlw b'01001111'	; 3
		goto prer11
prer5		movlw b'01100110'	; 4
		goto prer11
prer6		movlw b'01101101'	; 5
		goto prer11
prer7		movlw b'01111101'	; 6
		goto prer11
prer8		movlw b'00000111'	; 7
		goto prer11
prer9		movlw b'01111111'	; 8
		goto prer11
prer10		movlw b'01101111'	; 9
		goto prer11
prer41		movlw b'00000000'	;  ( )
prer11		btfsc relepriz
		iorlw b'10000000'	;  ,  
		movwf portb

		incf cher,f		;    
		movlw 4
		subwf cher,w
		btfsc _z
		clrf cher

prer_exit
		movf    status_temp,w     ; retrieve copy of STATUS register
		movwf	STATUS            ; restore pre-isr STATUS register contents
		swapf   w_temp,f
		swapf   w_temp,w          ; restore pre-isr W register contents
		retfie                    ; return from interrupt

		ORG 	0x090
		dt   	"        "
		dt	"TIMERLSV"
		dt 	"Ver 1.01"
		dt	" DISALL "
		dt	"company "
		dt	"for LSV "
		dt	"        "


; *********************************************************************
; *********************************************************************
; *********************************************************************
; ******************             **************************
; *********************************************************************
; *********************************************************************
; *********************************************************************
; *********************************************************************
; **** /    ***************************
; 1  WREG   0,1 
delay		movwf cnt0
delay0		movlw .100
		movwf cnt1
delay1		movlw .200
		movwf cnt2
delay2		nop
		nop
		decfsz cnt2,f
		goto delay2
		decfsz cnt1,f
		goto delay1
		decfsz cnt0,f
		goto delay0
		return
; **** /      *****************
;     
delay_min	movlw 2
delay3a		movwf cnt0
delay0a		movlw .5
		movwf cnt1
delay1a		movlw .200
		movwf cnt2
delay2a		nop
		nop
		decfsz cnt2,f
		goto delay2a
		decfsz cnt1,f
		goto delay1a
		decfsz cnt0,f
		goto delay0a
		return
delay_min1	movlw 1
		goto delay3a

; *********************************************************************
; *********************************************************************
; ********   ********************************************
;    WREG -   0,1 
sound		
		snd_on
		call delay
		snd_off
		return
	





; *********************************************************************
; *********************************************************************
; *********************************************************************
; **********************                *************************
; *********************************************************************
; *********************************************************************
; *********************************************************************
; *********************************************************************
; *********************************************************************
; *********************************************************************
; ***************               ********************
		org 0x100
		dt " BEGIN  "
		dt "MAIN COD"
		dt "  init  "
main
		BANKSEL PORTA		;   
		CLRF PORTA
		BANKSEL TRISA
		MOVLW PORTA_NAPR_IND
		MOVWF TRISA
		BANKSEL PORTA
		CLRF PORTA

		CLRF PORTB		;   
		BANKSEL TRISB
		MOVLW PORTB_NAPR_IND
		MOVWF TRISB
		BANKSEL PORTB
		CLRF PORTB

;		movlw b'01000010'	; OPTION    1:8
;		movlw b'01001111'	; OPTION   
		movlw b'01000000'	;     1:2???
		banksel OPTION_REG	;  ,   
		movwf OPTION_REG
		banksel PORTA

;   -       *****************
pusk		movlw b'11110000'
		movwf porta
		movlw b'00000000'
		movwf portb
;	goto test1
		pisk 1
		bsf portb,3
		pause 1
		bsf portb,4
		pisk 1
		bsf portb,2
		pause 1
		bsf portb,6
		pisk 1
		bsf portb,5
		pause 1
		bsf portb,1
		pisk 1
		bsf portb,0
		pisk 5
		pause .22


;     ********************
test1
		banksel raz1		;    
		clrf raz1
		clrf raz2
		clrf raz3
		clrf raz4
		clrf flash		;    
		clrf cher
		clrf flags
		clrf dig1
		clrf dig2
		clrf dig3
		clrf dig4
		movlw .50
		movwf time
		clrf tmr_add
;		movlw .8
		movlw .4
		movwf tmr_add
		movlw .7 		;    
		movwf TMR0
		bcf _t0if
		bsf _t0ie
		bsf _gie

		pisk 1
mmm1
		movf dig1,w		;   
		movwf raz1
		movf dig2,w
		movwf raz2
		movf dig3,w
		movwf raz3
		movf dig4,w
		movwf raz4



; *********************************************************************
; *********************************************************************
; *********************************************************************
; *******************                  ********************
; *********************************************************************
; *********************************************************************

; *********************************************************************
; *********************************************************************
; *****************      ****************
; *********************************************************************
; *********************************************************************
mmm
		rele_off		;  
		bsf mig			;  

mmm3		call delay_min		;  
		bcf _gie		;     ?
		banksel TRISB
		movlw PORTB_NAPR_K1
		movwf TRISB
		movlw PORTA_NAPR_K2
		movwf TRISA
		banksel portb
		bcf key_touch
		btfss key_start
		bsf key_touch

;mmm50	goto mmm50
		movlw raz1		;  
		movwf fsr
		movf flash,w
		addwf fsr,f
		bcf keys	
		btfsc key_0
		goto mmm30
		movlw 0
		goto mmm40
mmm30		btfsc key_1
		goto mmm31
		movlw 1
		goto mmm40
mmm31		btfsc key_2
		goto mmm32
		movlw 2
		goto mmm40
mmm32		btfsc key_3
		goto mmm33
		movlw 3
		goto mmm40
mmm33		btfsc key_4
		goto mmm34
		movlw 4
		goto mmm40
mmm34		btfsc key_5
		goto mmm35
		movlw 5
		goto mmm40
mmm35		btfsc key_6
		goto mmm36
		movlw 6
		goto mmm40
mmm36		btfsc key_7
		goto mmm37
		movlw 7
		goto mmm40
mmm37		btfsc key_8
		goto mmm38
		movlw 8
		goto mmm40
mmm38		btfsc key_9
		goto mmm39
		movlw 9
mmm40		movwf indf		;  
		bsf keys
		incf flash,f
		movlw 4
		subwf flash,w
		btfsc _z
		clrf flash
mmm39
		banksel TRISA
		movlw PORTB_NAPR_IND
		movwf TRISB
		movlw PORTA_NAPR_IND
		movwf TRISA
		banksel porta
		bsf _gie

		btfsc key_touch		;  ?
		goto mmm10

		btfss keys		;  ?
		goto mmm_end
		pisk 1
		pause 2

mmm_end		goto mmm3		;   


mmm10		movf raz1,w		;  
		movwf dig1		;    
		movf raz2,w
		movwf dig2
		movf raz3,w
		movwf dig3
		movf raz4,w
		movwf dig4
		pisk 2
		pause 2




; *********************************************************************
; *********************************************************************
; **********************   C O U N T D O W N   ************************
; *********************************************************************
; *********************************************************************
zzz
		rele_on
		movlw .50		;  0,1 
		movwf time
		bsf justsub
		bcf mig			;   


zzz1	
;		call delay_min1		;     
		bcf _gie		;     ?
		banksel TRISB
		movlw PORTB_NAPR_K1
		movwf TRISB
		movlw PORTA_NAPR_K2
		movwf TRISA
		banksel portb
		bcf key_touch
		btfss key_start
		bsf key_touch
		banksel TRISA
		movlw PORTB_NAPR_IND
		movwf TRISB
		movlw PORTA_NAPR_IND
		movwf TRISA
		banksel porta
		bsf _gie
		btfsc key_touch
		goto zzz_off
				

		movf raz1,f		;   0
		btfss _z
		goto zzz2
		movf raz2,f
		btfss _z
		goto zzz2
		movf raz3,f
		btfss _z
		goto zzz2
		movf raz4,f
		btfss _z
		goto zzz2
		goto zzz_off
zzz2
		btfsc justsub		;  ?
		goto zzz_end
		bsf justsub
		decf raz4,f		; 
		movlw 0xFF
		subwf raz4,w
		btfss _z
		goto zzz3
		movlw .9
		movwf raz4
		decf raz3,f		; 
		movlw 0xFF
		subwf raz3,w
		btfss _z
		goto zzz3
		movlw .9
		movwf raz3
		decf raz2,f		; 
		movlw 0xFF
		subwf raz2,w
		btfss _z
		goto zzz3
		movlw .9
		movwf raz2
		decf raz1,f		; 
zzz3

zzz_end		call delay_min1		;     
		goto zzz1

zzz_off		rele_off
		clrf flash
		pisk 5
		pause .10
		goto mmm1
		END 

